/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/*********************************************************************
**
** NAME:
**   nsdefs.cc
**
** DESCRIPTION:
**
**
** NOTES:
**
** HISTORY:
** $Log: nsdefs.cpp,v $
** Revision 1.1.1.1  2005/07/29 22:16:29  foxworth
** Importing new setup sdk for open source project
**
** Revision 1.3  2005/07/29 19:43:27  nkinder
** 164436 - Updated copyrights, licensed code under LGPL, and licensed docs under OPL
**
** Revision 1.2  2005/03/01 01:45:13  nhosoi
** Brand the Setup SDK as "Fedora"; updated copyrights
**
** Revision 1.1.1.1  2005/01/25 18:34:45  cvsadm
** Move SetupSDK from 6.2 development branch to TRUNK
**
** Revision 1.1.1.2  2001/11/06 01:51:31  ahakim
** XXX AOL/NSCP Copyright XXX
**
** Revision 1.1.1.1  1999/03/04 23:28:28  svbld
** importing setupsdk41 closer to the trunk
**
** Revision 1.1.2.32.6.6  1999/01/30 00:24:19  cxue
** release unused memory
**
** Revision 1.1.2.32.6.5  1999/01/07 02:41:43  cxue
** change buffer size for value to 2K
**
** Revision 1.1.2.32.6.4  1998/11/14 01:18:10  gbeasley
** unified api
**
** Revision 1.1.2.32.6.3  1998/11/09 17:39:23  cxue
** init _fileName
**
** Revision 1.1.2.32.6.2  1998/11/03 21:18:45  cxue
** NVPair.set takes int and unsigned int
**
** Revision 1.1.2.32.6.1  1998/09/25 23:09:58  cxue
** NVPair::set to take unsigned long value
**
** Revision 1.1.2.32  1998/07/17 02:24:11  pvo
** Eliminate some memory leaks
**
** Revision 1.1.2.31  1998/06/05 03:38:05  pvo
** 118281 - additional code for UTF8 conversion
**
** Revision 1.1.2.30  1998/06/01 21:07:19  pvo
** 118281 - support local encoding in install.inf
**
** Revision 1.1.2.29  1998/05/01 01:06:46  pvo
** Fix problem with skipping extraction
**
** Revision 1.1.2.28  1998/04/20 20:51:32  pvo
** 112701 - problem reconfiguring SIE
**
** Revision 1.1.2.27  1998/03/28 03:28:08  pvo
** 103621 - Support for 8-bit input.
**
** Revision 1.1.2.26  1998/03/26 03:18:58  pvo
** 111470 - Uninstall core dumps on IRIX.
**
** Revision 1.1.2.25  1998/03/04 02:27:40  pvo
** Added support for Ldif line continuation and common time format.
**
** Revision 1.1.2.24  1998/03/03 22:24:17  gbeasley
** removed warnings
**
** Revision 1.1.2.23  1998/02/26 01:39:34  gbeasley
** more sie integration
**
** Revision 1.1.2.22  1998/01/09 03:24:15  pvo
** Added a couple of add/set functions that operate on NVPair's section
** and fixed a problem with ux_time_stamp().
**
** Revision 1.1.2.21  1997/11/26 04:42:49  pvo
** Fixed up for cross-platform compilation.
**
** Revision 1.1.2.20  1997/11/26 02:04:31  pvo
** Fixed bugs and add capability to read NVPair from a file.
**
** Revision 1.1.2.19  1997/11/15 04:59:25  pvo
** Fixed memory leak problems and redo + operator for NSString.
**
** Revision 1.1.2.18  1997/11/14 09:11:25  pvo
** Various changes to strengthen code.
**
** Revision 1.1.2.17  1997/11/14 05:20:18  pvo
** Fixed a couple of  freeAttributes.
**
** Revision 1.1.2.16  1997/11/14 04:58:26  pvo
** Some code.
**
** Revision 1.1.2.15  1997/11/09 19:26:16  pvo
** API name changes. Added freeAttributes and freeListItems.
**
** Revision 1.1.2.14  1997/11/07 22:43:24  pvo
** New code to support uninstallation.
**
** Revision 1.1.2.13  1997/10/27 17:40:41  pvo
** Fixed bug causing installer not to read suitespot.pi correctly.
**
** Revision 1.1.2.12  1997/10/25 00:35:15  pvo
** Added ldap entry and SIE removal code.
**
** Revision 1.1.2.11  1997/10/24 03:39:29  pvo
** Final modification to make all work across platforms! Hope I make
** it this time.
**
** Revision 1.1.2.10  1997/10/23 03:23:30  pvo
** More change to support other platforms.
**
** Revision 1.1.2.9  1997/10/22 23:57:45  pvo
** Cross platform compilation.
**
** Revision 1.1.2.8  1997/10/16 04:22:43  pvo
** Quite a lot of code changes for ACI support.
**
** Revision 1.1.2.7  1997/10/14 05:01:54  pvo
** More code.
**
** Revision 1.1.2.6  1997/10/10 00:37:51  pvo
** Resolved conflict in namespace with zip library
**
** Revision 1.1.2.5  1997/10/06 23:43:26  pvo
** Cleaned up for NT compilation.
**
** Revision 1.1.2.4  1997/10/06 22:48:49  pvo
** Removed more dependencies
**
** Revision 1.1.2.3  1997/10/06 22:48:31  pvo
** Used standard ctime().
**
** Revision 1.1.2.2  1997/10/06 21:06:43  pvo
** Additional code. Pirated routine time_stamp from util_ctime.
**
** Revision 1.1.2.1  1997/10/06 20:36:37  pvo
** Restructure depdencies and changed suffixes from .cc to .cpp
**
** Revision 1.1.2.8  1997/10/04 01:49:05  pvo
** Added LdapEntry update code.
**
** Revision 1.1.2.7  1997/09/27 02:46:57  pvo
** Checked in.
**
*********************************************************************/
extern "C" {
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
}

#include "prodinfo.h"
#include "nsdefs.h"
#include "setupapi.h"

class NSStringRep
{
public:
  NSStringRep()
    : _refcount(0), _data(0), _length(0)
     { }
  NSStringRep(const char* b,  long len);

  ~NSStringRep();

  int _refcount;
  char * _data;
  long _length;
};

NSStringRep::NSStringRep(const char* b,  long len)
{
  _refcount = 0;
  _length = len;
  _data = new char[len]; // Include \0
  strncpy (_data, b, len);
  _data[len-1] = 0; // PVO - just for now
}

NSStringRep::~NSStringRep()
{
   if (_data) delete[] _data;
}

//////////////////////////////////////////////////////////////////////
// NSString
//////////////////////////////////////////////////////////////////////

void
NSString::init(const char *b, int length)
{
  if (b != NULL && length > 0)
  {
     length = ( ((long) strlen(b)) > length) ? length : strlen(b);
     _rep = new NSStringRep(b, length+1); // Add a \0
     _rep->_refcount++;
     _data = _rep->_data;
     _length = _rep->_length-1; // Really "string" length
  }
}

NSString::NSString()
{
  _rep = 0;
  _data = 0;
  _length = 0;
}

NSString::NSString(const char* b, int length)
  :_rep(0), _data(0), _length(0)
{
   init(b, length);
}

NSString::NSString(const char *b)
  :_rep(0), _data(0), _length(0)
{
   if (b != NULL)
   {
      init(b, strlen(b));
   }
}

NSString::NSString(const NSString& s)
   :_rep(0), _data(0), _length(0)
{
   assign(s);
}

NSString::NSString (const char *s1, long l1, const char *s2, long l2)
   :_rep(0), _data(0), _length(0)
{
   long total = l1 + l2;

   if (total)
   {
      char *tmp = new char [total+1];

      if (s1)
      {
         strncpy(tmp, s1, l1);
      }
      if (s2)
      {
         strncpy(tmp+l1,s2,l2);
      }

      tmp[total] = 0;

      _rep = new NSStringRep;
      _rep->_refcount = 1;
      _rep->_data = tmp;
      _rep->_length = total+1;

      _data = _rep->_data;
      _length = total;
   }
}
void
NSString::assign(const NSString & s)
{
   if (s._rep)
   {
      _rep = s._rep;
      _rep->_refcount++;
      _data = _rep->_data;
      _length = s._length;
   }
}

NSString &
NSString::operator = (const char *s)
{
   if (s != _data)
   {
      clear();

      if (s)
      {
         init(s, strlen(s));
      }
   }
   return *this;
}

NSString &
NSString::operator = (const NSString& s)
{
  if (this != &s)
  {
     clear();
     assign(s);
  }
  return *this;
}

NSString::~NSString()
{
   clear();
}

void
NSString::clear()
{
  if (_rep) {
    _rep->_refcount--;
    if (_rep->_refcount <= 0) {
      delete _rep;
    }
  }
  _rep = NULL;
  _data = NULL;
  _length = 0;

}

// return 1 if same. 0 otherwise.
int NSString::operator == (const char *s) const
{
  if (_length == 0 && s == NULL)
  {
    return 1;
  }
  else if (s == NULL)
  {
    return 0;
  }

  if ((_length == ((long)strlen(s))) && (strcmp(_data, s) == 0))
    return 1;

  return 0;
}

int NSString::operator == (const NSString & s) const
{
   return NSString::operator == (s.data());
}

int NSString::operator != (const NSString & s) const
{
   return (!(NSString::operator == (s)));
}

int NSString::operator != (const char *s) const
{
   return (!(NSString::operator == (s)));
}

NSString operator + (const NSString &s1, const NSString &s2)
{
   return NSString(s1.data(), s1.length(), s2.data(), s2.length());
}

NSString operator + (const NSString &s1, const char *s2)
{
   return NSString(s1.data(), s1.length(), s2, (s2) ? strlen(s2): 0);
}

NSString operator + (const char *s1, const NSString &s2)
{
   return NSString(s1, s1 ? strlen(s1): 0, s2.data(), s2.length());
}

/*********************************************************************
**
** CLASS: NVPair
**
*********************************************************************/

void
NVPair::init(const char *fileName)
{
   _block = (NVPairImp *) ADM_pi_init(fileName,_format);
   if (fileName)
   {
      _fileName = strdup(fileName);
   }
   else
   {
      _fileName = NULL;
   }
   _removable = True;
}

NVPair::NVPair()
   :_format(0)
{
   _fileName = NULL;
   init();
}

NVPair::NVPair(const char *fileName)
   :_format(0)
{
   init (fileName);
}

NVPair::NVPair(const NVPair &blk)
{
   init();
   if (blk._block)
   {
      ADM_pi_copy((ADM_piTree*)_block, (ADM_piTree *)blk._block);
      _fileName = blk._fileName;
      _id = blk._id;
   }
   _format = blk._format;
}

NVPair::~NVPair()
{
   if (_removable)
   {
      ADM_pi_done((ADM_piTree *) _block);
   }

   _block = NULL;

   if (_fileName)
      free(_fileName);
   _fileName = NULL;
}

void
NVPair::clear()
{
   if (_block)
   {
      if (_removable)
      {
         ADM_pi_done ((ADM_piTree *) _block);
      }
      _block = (NVPairImp *) ADM_pi_init(NULL);
   }

   _id = (const char *) NULL;

   if (_fileName)
   {
      free(_fileName);
      _fileName = NULL;
   }
   _format = 0;
}

void
NVPair::read(const char *fileName)
{
   int format = _format;
   clear();
   _format = format;
   init(fileName);
}

NVPair &
NVPair::operator = (const NVPair &p)
{
   if (this != &p)
   {
      if (_block)
      {
         if (_removable)
         {
            ADM_pi_done ((ADM_piTree *) _block);
         }
         _block = NULL;
      }
      init();
      if (p._block)
      {
         ADM_pi_copy((ADM_piTree *) _block, (ADM_piTree *)p._block);
         _id = p._id;
      }
      else
      {
         _id = (const char *) NULL;
      }
   }
   return *this;
}

void
NVPair::id(const char *blockID)
{
   _id = blockID;
}

const char *
NVPair::timeStamp() const
{
   if (_block)
   {
      return (ADM_pi_when((ADM_piTree *)_block));
   }
   else
      return NULL;
}

void
NVPair::stampTime()
{
   if (_block)
   {
      char buf[BUFSIZ];
      get_gmtime (buf, BUFSIZ);
      ADM_pi_timeStamp((ADM_piTree *)_block, buf);
   }
}

Bool
NVPair::isEmpty() const
{
   ADM_piTree *p = (ADM_piTree *) _block;
   if (p == NULL ||
       (p->when == NULL && p->numVars == 0 && p->numBools == 0 &&
        p->numLists == 0 && p->numSects == 0))
   {
      return True;
   }
   else
   {
      return False;
   }
}

int
NVPair::numName() const
{
   ADM_piTree *p = (ADM_piTree *)_block;
   if (p == NULL)
      return 0;
   else
      return p->numVars;
}

int
NVPair::numList() const
{
   ADM_piTree *p = (ADM_piTree *)_block;
   if (p == NULL)
      return 0;
   else
      return p->numLists;
}

int
NVPair::numListItems(const char *list) const
{
   char **tmp;
   int num;
   if (list != NULL && _block != NULL)
   {
      ADM_pi_2List((ADM_piTree *) _block, list);
      num = ADM_pi_list((ADM_piTree *) _block, list, &tmp);
   }
   if (num>0)
     return num;
   else
     return 0;
}

const char *
NVPair::get(const char *label) const
{
   if (_block == NULL)
   {
      return NULL;
   }
   else
   {
      return ADM_pi_value((ADM_piTree *) _block, label);
   }
}

void
NVPair::set(const char *label, const char *value)
{
   if (_block)
   {
      ADM_pi_setValue((ADM_piTree *) _block, label, value);
   }
   return;
}

void
NVPair::set(const char *label, long value)
{
   if (_block)
   {
      char buf[BIG_BUF];
      sprintf(buf,"%ld", value);
      set(label, buf);
   }
}

void
NVPair::set(const char *label, unsigned long value)
{
   if (_block)
   {
      char buf[BIG_BUF];
      sprintf(buf,"%lu", value);
      set(label, buf);
   }	
}

void
NVPair::set(const char *label, int value)
{
   set(label, (long) value);
}

void
NVPair::set(const char *label, unsigned int value)
{
   set(label, (unsigned long) value);
}

void
NVPair::set(const char *label, const NSString &value)
{
   set(label, value.data());
}


void
NVPair::set(const char *sectionName, const char *label, const char *value)
{
   NVPair *section;
   if (sectionName == NULL)
   {
      return;
   }
   else
   {
      section = createSection(sectionName);
      section->set(label, value);
   }
   return;
}

void
NVPair::set(const char *section, const char *label, const NSString &value)
{
   set(section, label, value.data());
}

void
NVPair::set(const char *sectionName, const char *label, long value)
{
   NVPair *section;
   if (sectionName == NULL)
   {
      return;
   }
   else
   {
      section = createSection(sectionName);
      section->set(label, value);
   }
}

void
NVPair::toUTF8(const char *label)
{
   if (_block)
   {
      ADM_pi_convertEncoding((ADM_piTree *) _block, label, 1);
   }
}

void
NVPair::toLocal(const char *label)
{
   if (_block)
   {
      ADM_pi_convertEncoding((ADM_piTree *) _block, label, 0);
   }
}

void
NVPair::rename(const char *src, const char *dest)
{
   if (_block)
      ADM_pi_rename((ADM_piTree *) _block, src, dest);
}

void
NVPair::remove(const char *label)
{
   if (_block)
      ADM_pi_delValue((ADM_piTree *)_block, label);
}

Bool
NVPair::inList(const char *label, const char *value) const
{
   Bool ret = False;

   if (_block != NULL && label != NULL && value != NULL)
   {
      ADM_pi_2List ((ADM_piTree *) _block, label);
      if (ADM_pi_canDo( (ADM_piTree *)_block, label, value) > 0)
      {
         ret = True;
      }
   }
   return ret;
}

Bool
NVPair::listExists(const char *label) const
{
   Bool ret = False;
   char **tmp = NULL;

   if (_block != NULL && label != NULL)
   {
      if (ADM_pi_list((ADM_piTree *) _block, label, &tmp) > 0)
      {
         ret = True;
      }
   }
   return ret;
}

char **
NVPair::getListItems(const char *label) const
{
   char **list = NULL;
   char **tmp = NULL;
   int num = 0;

   if (label != NULL && _block != NULL)
   {
      ADM_pi_2List((ADM_piTree *) _block, label);
      num = ADM_pi_list((ADM_piTree *) _block, label, &tmp);
   }

   if (num > 0)
   {
      list = (char **) malloc (sizeof(char *)*(num+1));
      for (int i = 0; i < num ; ++i)
      {
         if (tmp[i])
         {
            list[i] = strdup(tmp[i]);
         }
      }
      list[num] = NULL;
   }
   return list;
}

void
NVPair::freeListItems (char **items)
{
   if (items)
   {
      char **tmp = items;

      while (*tmp)
      {
         free(*tmp);
         *tmp = NULL;
         ++tmp;
      }
      free(items);
   }
}

const char *
NVPair::getListItem(const char *label, int index) const
{
   char **list;

   if (label == NULL || index < 0 || _block == NULL)
   {
      return NULL;
   }
   else
   {
      int num;

      ADM_pi_2List ((ADM_piTree *) _block, label);

      num = ADM_pi_list((ADM_piTree *) _block, label, &list);

      if (num <= 0 || index > (num -1))
      {
         /* Out of Range */
         return NULL;
      }
      else
      {
         return list[index];
      }
   }
}

void
NVPair::delList(const char *label)
{
   if (label != NULL && _block != NULL)
   {
      ADM_pi_2List ((ADM_piTree *) _block, label);
      ADM_pi_delList((ADM_piTree *) _block, label);
   }
}

void
NVPair::delListItem(const char *label, const char *value)
{
   if (label == NULL || value == NULL || _block == NULL)
   {
      return;
   }
   ADM_pi_2List ((ADM_piTree *) _block, label);
   ADM_pi_delCapability((ADM_piTree *) _block, label, value);
}

void
NVPair::add(const char *label, const char *value)
{
   if (_block)
   {
      ADM_pi_2List ((ADM_piTree *) _block, label);
      ADM_pi_setCapability((ADM_piTree *) _block, label, value);
   }
   return;
}

void
NVPair::add(const char *label, const NSString & value)
{
   add(label, value.data());
}

void
NVPair::add(const char *label, const char **values)
{
   if (_block && values)
   {
      while (*values)
      {
         add(label, *values);
         values++;
      }
   }
}

void
NVPair::add(const char *sectionName, const char *label, const char *value)
{
   NVPair *section;
   if (sectionName == NULL)
   {
      return;
   }
   else
   {
      section = createSection(sectionName);
      section->add(label, value);
   }
}

void
NVPair::add(const char *sectionName, const char *label, const NSString & value)
{
   add(sectionName, label, value.data());
}

void
NVPair::add(const char *sectionName, const char *label, const char **values)
{
   NVPair *section;
   if (sectionName == NULL)
   {
      return;
   }
   else
   {
      section = createSection(sectionName);
      section->add(label, values);
   }
}

const char *
NVPair::name(int i) const
{
   if (_block && i >= 0 && i < ((ADM_piTree *)_block)->numVars)
   {
      return ((ADM_piTree *)_block)->vars[i];
   }
   else return NULL;
}

const char *
NVPair::list (int i) const
{
   if (_block && i >= 0 && i < ((ADM_piTree *)_block)->numLists)
   {
      return ((ADM_piTree *)_block)->lists[i].var;
   }
   else return NULL;
}

int
NVPair::numSections() const
{
   if (_block == NULL)
   {
      return 0;
   }
   else
   {
      return (((ADM_piTree *)_block)->numSects);
   }
}

NVPair *
NVPair::getSection(int i)
{
   NVPair *p;
   ADM_piTree *src;

   if (numSections() == 0 || (src = ADM_pi_nsection((ADM_piTree *)_block,i)) == NULL)
   {
      return NULL;
   }
   else
   {
      p = new NVPair();

      // ADM_pi_copy ((ADM_piTree *) p->_block, src);
      if (p->_block)
      {
         free (p->_block);
      }

      p->_block = (NVPairImp *) src;

      p->_id = ADM_pi_sectName ((ADM_piTree *)_block, i);

      p->_removable = False;

      return p;
   }
}

NVPair *
NVPair::getSection(const char *name)
{
   NVPair *p;
   ADM_piTree *src;

   if (numSections() == 0 || (src = ADM_pi_section((ADM_piTree *)_block,name)) == NULL)
   {
      return NULL;
   }
   else
   {
      p = new NVPair();
      if (p->_block)
      {
         free (p->_block);
      }
      p->_block = (NVPairImp *) src;
      p->_id = name;
      p->_removable = False;
      return p;
   }
}

NVPair *
NVPair::createSection(const char *name)
{
   NVPair *section;

   section = getSection(name);

   if (section == NULL)
   {
      section = new NVPair;
      addSection(name, section);
      delete section;
      section = getSection(name);
   }
   return section;
}

void
NVPair::addSection(const char *name, NVPair *p)
{
   ADM_piTree *dest;
   int i, j;
   const char *s, *val;

   if (p == NULL)
   {
       return;
   }
   else if (name == NULL)
   {
      for (i = 0; i < p->numName(); i++)
      {
         s = p->name(i);
         set(s, p->get(s)); // Replace
      }

      for (i=0; i < p->numList(); i++)
      {
         s = p->list(i);

         for (j = 0; (val = p->getListItem(s, j)) != NULL; j++)
         {
            add(s, val);
         }
      }
   }
   else
   {
      // If something is there, remove it
      ADM_pi_delSection((ADM_piTree *)_block, name);

      // Add a new section
      dest = ADM_pi_addSection ((ADM_piTree *)_block, name);

      ADM_pi_copy (dest, (ADM_piTree *)p->_block);

/*
      ADM_pi_done((ADM_piTree *)p->_block);

      p->_block = (NVPairImp *) dest;

      p->_id = name;

      p->_removable = False;
*/
   }
}


int
NVPair::write() const
{
   return write(_fileName);
}

int
NVPair::write(const char *fileName) const
{
   if (_block == NULL)
   {
      return -1;
   }
   return (ADM_pi_write((ADM_piTree *) _block, fileName));
}

void
NVPair::setFormat(int which)
{
   _format = which;
   if (_block == NULL)
      return;
   ADM_pi_setFormat((ADM_piTree *)_block,which);
}

/*
 * Miscellaneous functions
 */

extern "C" {

NSAPI_EXTERN void
get_gmtime(char *buf, int buflen)
{
   setupGetGmtime(buf, buflen);
   return;
}
   
}
