/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/***********************************************************************
** NAME
**   dl-inst.h
**
** DESCRIPTION
**   Common dialog routines for Installer
**
** NOTES:
**
** HISTORY
**
** $Log: dl-inst.h,v $
** Revision 1.1.1.1  2005/07/29 22:16:31  foxworth
** Importing new setup sdk for open source project
**
** Revision 1.3  2005/07/29 19:43:29  nkinder
** 164436 - Updated copyrights, licensed code under LGPL, and licensed docs under OPL
**
** Revision 1.2  2005/03/01 01:45:17  nhosoi
** Brand the Setup SDK as "Fedora"; updated copyrights
**
** Revision 1.1.1.1  2005/01/25 18:34:45  cvsadm
** Move SetupSDK from 6.2 development branch to TRUNK
**
** Revision 1.1.1.1  1999/03/04 23:27:02  svbld
** importing setupsdk41 closer to the trunk
**
** Revision 1.1.2.7  1998/03/02 23:59:26  pvo
** 106912 - Pickup the right defaults in dialogs.
** 105320 - Improve logging of silent installation.
**
** Revision 1.1.2.6  1998/02/24 00:23:07  pvo
** Support for topology changes.
**
** Revision 1.1.2.5  1998/02/15 22:06:39  pvo
** 106679 - Support standalone installation of MCC.
**
** Revision 1.1.2.4  1997/12/12 21:54:17  pvo
** Various bug fixes.
**
** Revision 1.1.2.3  1997/11/26 02:02:54  pvo
** Restructure files and add Download support.
**
**
***********************************************************************/

#ifndef NS_DLINST_H
#define NS_DLINST_H

#include "dialog.h"

extern DialogYesNo welcome;

extern DialogYesNo askLicense;

extern DialogInput askClientOrServer;

extern DialogInput askInstallType;

extern DialogInput askServerRoot;

extern DialogInput askClientRoot;

extern DialogInput askHostname;

extern DialogInput askSSUser;

extern DialogInput askInstallDN;

extern DialogYesNo removeInstallInfo;

#endif
