/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/*********************************************************************
** NAME:
**   inst_stub.cc
**
** DESCRIPTION:
**   Stub used when Installer code is not needed
**
** NOTES:
**
** HISTORY:
** $Log: inst_stub.cc,v $
** Revision 1.1.1.1  2005/07/29 22:16:31  foxworth
** Importing new setup sdk for open source project
**
** Revision 1.3  2005/07/29 19:43:29  nkinder
** 164436 - Updated copyrights, licensed code under LGPL, and licensed docs under OPL
**
** Revision 1.2  2005/03/01 01:45:17  nhosoi
** Brand the Setup SDK as "Fedora"; updated copyrights
**
** Revision 1.1.1.1  2005/01/25 18:34:45  cvsadm
** Move SetupSDK from 6.2 development branch to TRUNK
**
** Revision 1.1.1.1  1999/03/04 23:27:03  svbld
** importing setupsdk41 closer to the trunk
**
** Revision 1.1.2.5  1998/08/20 18:06:42  cxue
** getLocalLdapInfo
**
** Revision 1.1.2.4  1998/08/20 01:37:31  cxue
** verifyInstallDomain
**
** Revision 1.1.2.3  1998/07/25 06:31:25  cxue
** Bug 302072. add logic to auto-detect UserDirectoryURL from DS4.0. This can avoid to ask UserDirectoryURL many times during installation. Requested by Sunil. Reviewed by Phong.
**
** Revision 1.1.2.2  1998/06/24 17:41:13  pvo
** 129804 - support UserDirectoryAuth
**
** Revision 1.1.2.1  1998/02/26 04:01:58  pvo
** Fixed break in download.cc due to the call to set_ldap_option() in libinstall.
** Also try to detect input error when asking for installDN and try to
** create installDN if possible in case the user has the privilege to create
** it.
**
**
**
*********************************************************************/
#include "installer.h"
NSString
Installer::verifyInstallPrivilege(const char *a, const char *b, const char *c, const char *d)
{
   return (char *) NULL;
}

NSString
Installer::getUserDirectory (const char *ldapURL, const char *ldapUser, const char *ldapPwd, const char *installDN, char **url, char **bindDN, char **bindPwd)
{
	return (char *) NULL;
}


Bool
Installer::needUserDirAuth()
{
   return False;
}

NSString
Installer::verifyInstallDomain (const char *ldapURL, const char *installDN)
{
   return (char *) NULL;
}

Bool 
Installer::getLocalLdapInfo (char ** ldapURL, char ** ldapUser, char **installDN)
{
   return True;
}

