/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/***********************************************************************
** Name: ux-curse.h
**
** Based on Rob's code, modified enough to only install nsadmin.
** Definitions shared between server setup programs.
** Intended for UNIX only, and not thread safe.
**
***********************************************************************/

#ifndef ux_curse_h
#define ux_curse_h

/***********************************************************************
** Includes
***********************************************************************/

#ifdef	AIX
#undef	SYSV
#endif

#if defined(OSF1)
/* Digital Unix V4.0 defines a variable CR in the curses.h,
	but it is a #define in public/nsapi.h, so undefine it
	here before including curses.h */
#undef CR
#endif


#ifdef __cplusplus
extern "C" {
#endif

#include <stdarg.h>     /* for the *_message functions below */
#include <curses.h>     /* various */

/* #include "base/file.h" */  /* system_errmsg */

#if defined (AIX)
extern int printw(char *, ...);
#endif

#define TEMP_STRING_SIZE 1024

#define	WHAT_SERVER "SuiteSpot"

#define YES 1
#define NO  0

/* From ux-curse.c */
void init_screen(const char *server, const char *caption);
int grab_string(char *t, int l, const char *deft);
int grab_pw_string(char *t, int l, const char *deft);
void print_centered(int width, const char *msg);
void print_oneplace(const char *msg);
void show_message(const char *msg, ...);
void exit_message(const char *msg, ...);

int  w_refresh(void);
int  w_endwin(void);
int  w_initscr(void);
int  w_isendwin(void);

void new_page(void);

int  w_ask_yes_no(int defaultVal);

void disableScreenBack();
/*
void stuff_buffer(const char *msg);
*/

#ifdef  __cplusplus
}
#endif

#endif /* ux-curse_h */
