/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/********************************************************************
** NAME:
**   install.cc
**
** DESCRIPTION:
**   Installation Program for servers
**
** NOTES:
**
** HISTORY:
** $Log: setup.cc,v $
** Revision 1.1.1.1  2005/07/29 22:16:32  foxworth
** Importing new setup sdk for open source project
**
** Revision 1.3  2005/07/29 19:43:29  nkinder
** 164436 - Updated copyrights, licensed code under LGPL, and licensed docs under OPL
**
** Revision 1.2  2005/03/01 01:45:17  nhosoi
** Brand the Setup SDK as "Fedora"; updated copyrights
**
** Revision 1.1.1.1  2005/01/25 18:34:45  cvsadm
** Move SetupSDK from 6.2 development branch to TRUNK
**
** Revision 1.1.1.2  1999/05/20 19:01:02  cxue
** Patch database behaviors same as NT
**
** Revision 1.1.1.1  1999/03/04 23:27:07  svbld
** importing setupsdk41 closer to the trunk
**
** Revision 1.1.2.10.12.1  1999/02/04 02:24:46  cxue
** remove temporary info file if process is killed by crtl-c. corect english sentences. Skip user/group dialog if needed
**
** Revision 1.1.2.10  1997/12/12 21:54:22  pvo
** Various bug fixes.
**
** Revision 1.1.2.1  1997/11/26 02:02:56  pvo
** Restructure files and add Download support.
**
** Revision 1.1.2.2  1997/09/27 02:47:18  pvo
** Checked in.
**
*********************************************************************/
extern "C" {
#include "signal.h"
};

#include "installer.h"

Installer *installer = NULL;

void signalHandler(int signal)
{
   printf("\nInterrupt [%d]. Installation aborts.\n", signal);

   installer->terminate(2);
}

void initSignalHandler()
{
   /* set global signal handler for setup and unzip */
   signal(SIGINT, signalHandler);   
   setUnzipSigHandler(signalHandler);
}


int
main(int argc, char **argv)
{
   initSignalHandler();

   installer = new Installer (argc, argv);

   if (installer->init() == 0)
   {
      installer->run();
   }

   delete installer;

	return 0;
}
