/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/********************************************************************
** NAME:
**   uninstall.cc
**
** DESCRIPTION:
**   Uninstallation Program for servers
**
** NOTES:
**
** HISTORY:
** $Log: uninstall.cc,v $
** Revision 1.1.1.1  2005/07/29 22:16:32  foxworth
** Importing new setup sdk for open source project
**
** Revision 1.3  2005/07/29 19:43:29  nkinder
** 164436 - Updated copyrights, licensed code under LGPL, and licensed docs under OPL
**
** Revision 1.2  2005/03/01 01:45:17  nhosoi
** Brand the Setup SDK as "Fedora"; updated copyrights
**
** Revision 1.1.1.1  2005/01/25 18:34:45  cvsadm
** Move SetupSDK from 6.2 development branch to TRUNK
**
** Revision 1.1.1.1  1999/03/04 23:27:07  svbld
** importing setupsdk41 closer to the trunk
**
** Revision 1.1.2.2.12.1  1999/02/04 02:24:46  cxue
** remove temporary info file if process is killed by crtl-c. corect english sentences. Skip user/group dialog if needed
**
** Revision 1.1.2.2  1997/11/26 02:03:02  pvo
** Restructure files and add Download support.
**
** Revision 1.1.2.1  1997/11/09 19:30:13  pvo
** More code for uninstallation. Changed ns-remove.cc to uninstall.cc.
** Removed second password prompt when asking Ldap user.
**
** Revision 1.1.2.1  1997/11/08 16:47:46  pvo
** New. Uninstallation support.
**
*********************************************************************/

#include <signal.h>

#include "uninstaller.h"

UnInstaller *uninstaller;

void signalHandler(int signal)
{
   printf("\nInterrupt [%d]. Uninstallation aborts.\n", signal);

   uninstaller->terminate(2);
}


int
main(int argc, char **argv)
{
   signal(SIGINT, signalHandler);   

   uninstaller = new UnInstaller (argc, argv);

   if (uninstaller->init() == 0)
   {
      uninstaller->run();
   }

   delete uninstaller;
}
